#define _POSIX_C_SOURCE  200112L
#include <signal.h>
#include <unistd.h>
#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <sys/uio.h>

#include <conn.h>


int cmd(const char str[], char *buf) {
    int tobc[2];
    int frombc[2];

    int notused;
    SYSCALL(notused, pipe(tobc), "pipe1");
    SYSCALL(notused, pipe(frombc), "pipe2");

    if (fork() == 0) {
	// chiudo i descrittori che non uso
	SYSCALL(notused, close(tobc[1]), "close");  
	SYSCALL(notused, close(frombc[0]), "close");

	SYSCALL(notused, dup2(tobc[0],0),   "dup2 child (1)");  // stdin 
	SYSCALL(notused, dup2(frombc[1],1), "dup2 child (2)");  // stdout
	SYSCALL(notused, dup2(frombc[1],2), "dup2 child (3)");  // stderr

	execl("/usr/bin/bc", "bc", "-l", NULL);
	return -1;
    }

    // chiudo i descrittori che non uso
    SYSCALL(notused, close(tobc[0]), "close");
    SYSCALL(notused, close(frombc[1]), "close");

    int n;
    SYSCALL(n, write(tobc[1], str,strlen(str)), "write");
    SYSCALL(n, read(frombc[0], buf, BUFSIZE), "read");  // leggo il risultato o l'errore
    SYSCALL(notused, close(tobc[1]), "close");  // si chiude lo standard input di bc cosi' da farlo terminare
    SYSCALL(notused, wait(NULL), "wait");
    return n;
}

static void cleanup() {
    unlink(SOCKNAME);
}

static void sighandler(int useless) { 
    cleanup();
    _exit(0);
}

int main(int argc, char *argv[]) {
    // se qualcosa va storto ....
    atexit(cleanup);

    // installo il signal handler per tutti i segnali che mi interessano
    struct sigaction sa;
    // resetto la struttura
    memset (&sa, 0, sizeof(sa));   
    sa.sa_handler = sighandler;
    int useless;
    SYSCALL(useless,sigaction(SIGINT,   &sa, NULL), "sigaction");
    SYSCALL(useless,sigaction(SIGQUIT,  &sa, NULL), "sigaction");
    SYSCALL(useless,sigaction(SIGTERM,  &sa, NULL), "sigaction");


    int listenfd;
    // creo il socket
    SYSCALL(listenfd, socket(AF_UNIX, SOCK_STREAM, 0), "socket");

    // setto l'indirizzo 
    struct sockaddr_un serv_addr;
    memset(&serv_addr, '0', sizeof(serv_addr));
    serv_addr.sun_family = AF_UNIX;    
    strncpy(serv_addr.sun_path, SOCKNAME, strlen(SOCKNAME)+1);

    int notused;
    // assegno l'indirizzo al socket 
    SYSCALL(notused, bind(listenfd, (struct sockaddr*)&serv_addr,sizeof(serv_addr)), "bind");
  
    // setto il socket in modalita' passiva e definisco un n. massimo di connessioni pendenti
    SYSCALL(notused, listen(listenfd, 1), "listen");

    int connfd, n;
    do {
	SYSCALL(connfd, accept(listenfd, (struct sockaddr*)NULL ,NULL), "accept");
	while(1) {      
	    msg_t str;
	    char buffer[BUFSIZE];
	    
	    memset(str.str, '\0', BUFSIZE);
	    // leggo la size della stringa
	    SYSCALL(n, read(connfd, &str.len, sizeof(int)), "read1");
	    // leggo la stringa
	    SYSCALL(n, read(connfd, str.str, str.len), "read2");
	    if (n==0) break;
	    memset(buffer, '\0', BUFSIZE);
	    if ((n = cmd(str.str, buffer)) < 0) { 
		fprintf(stderr, "Errore nell'esecuzione del comando\n");
		break;
	    }
	    buffer[n] = '\0';
	    
	    // invio la risposta
	    // qui si puo' utilizzare invece che writev (man 2 writev) 2 write distinte
	    struct iovec iov[2] = { {&n, sizeof(int)}, {buffer, n} };
	    SYSCALL(notused, writev(connfd, iov, 2), "writev");
	}
	close(connfd);   
	printf("connection done\n");
    } while(1);
    return 0;
}
